#include <stdio.h>
#include<stdlib.h>

#include "dblist.h"

void Init(dblist *l)
{
	l->first = NULL;
	l->last = NULL;
	l->work_stack = 0;
}

long double  get_work(dblist *l){
	return l->work_stack;
}
/******************************************************************************/

void PushBack(dblist *l, void *val)
{
	elem *nouv = malloc(sizeof(elem));
	if(!nouv) exit(EXIT_FAILURE);
	nouv->value = val;
	nouv->prev = l->last;
	nouv->next = NULL;
	if(l->last) l->last->next = nouv;
	else l->first = nouv;
	l->last = nouv;        
}
/******************************************************************************/

void PushFront(dblist *l, void* val)
{
	elem *nouv = malloc(sizeof(elem));
	if(!nouv) exit(EXIT_FAILURE);
	nouv->value = val;
	nouv->next = l->first;
	nouv->prev = NULL;      
	if(l->first) l->first->prev = nouv;
	else l->last = nouv;
	l->first = nouv;
}
/******************************************************************************/

void* PopBack(dblist *l)
{
	void* val;
	elem *tmp = l->last;
	if(!tmp) return NULL;
	val = tmp->value;
	l->last = tmp->prev;
	if(l->last) l->last->next = NULL;
	else l->first = NULL;
	free(tmp);
	return val;
}
/******************************************************************************/

void* PopFront(dblist *l)
{
	void* val;
	elem *tmp = l->first;
	if(!tmp) return NULL;
	val = tmp->value;
	l->first = tmp->next;
	if(l->first)l->first->prev = NULL;
	else l->last = NULL;
	free(tmp);
	return val;
}
/******************************************************************************/

elem *GetBack(dblist *l)
{
	return l->last;
}
/******************************************************************************/

elem *GetFront(dblist *l)
{
	return l->first;
}
/******************************************************************************/

void* Remove(dblist *l, elem *e){
	void *val = e->value;
	if (l->first == e){
		return PopFront(l);	
	}else if (l->last == e){
		return PopBack(l);	
	}else{
		e->prev->next = e->next;
		e->next->prev = e->prev;
	}
	free(e);
	return val;
}
/******************************************************************************/

void View(dblist l)
{
	elem *pelem = l.first;
	while(pelem)
	{
		printf("%d\n",pelem->value);
		pelem = pelem->next;
	}
}
/******************************************************************************/

void Clear(dblist *l)
{
	elem *tmp;
	elem *pelem = l->first;
	while(pelem)
	{
		tmp = pelem;
		pelem = pelem->next;
		free(tmp);
	}
	l->first = NULL;
	l->last = NULL;
}
