#ifndef CGI_DBLIST_H
#define CGI_DBLIST_H

/*  Structure représantant un élément de la liste. */

typedef struct elem
{
	void * value;
	struct elem *prev;
	struct elem *next;
} elem ;

/*  Structure d'accés à la liste. */

typedef struct
{
	elem *first;
	elem *last;
	long double work_stack;
}dblist;

#ifdef __cplusplus
extern "C" {
#endif

	/*  Initialisation de la liste. */

	void Init(dblist *l);

	/*  Ajout d'une valeur en fin de liste. */

	void PushBack(dblist *l, void * val);

	/*  Ajout d'une valeur en début de liste. */

	void PushFront(dblist *l, void * val);

	/*  Retrait d'une valeur en fin de liste. */

	void * PopBack(dblist *l);

	/*  Retrait d'une valeur en début de liste. */

	void * PopFront(dblist *l);

	/*  Retourne l'element en fin de liste. */

	elem *GetBack(dblist *l);

	/*  Returne l'element en début de liste. */

	elem *GetFront(dblist *l);

	/*  Supprimme l'element de la liste. */

	void* Remove(dblist *l, elem *e);

	/*  Affichage de toute la liste. */

	void View(dblist l);

	long double get_work(dblist *l);

	/*  Vidage de toute la liste. */

	void Clear(dblist *l);

#ifdef __cplusplus
}
#endif

#endif
