#!/usr/bin/perl
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my %cost_edge;
my %cost_node;
my %nodes;
my %edge;
my %edge_reverse;
my %lp_nodes;

sub calcul_recursive {
	my $node = shift;
	return $nodes{$node} if $nodes{$node} !=0;
	my $lp = $default_size_node;
	$lp = $cost_node{$node} if defined $cost_node{$node};
	my $max = 0;
	my $tmp = 0;
	foreach (@{$edge{$node}}) {
		$tmp = calcul_recursive($_); 	
		if ($tmp > $max){
			$max = $tmp;
			$lp_nodes{$node} = $_ ;
		}
	}
	$lp += $max;
	$nodes{$node} = $lp;
	return $lp;
}



open( FILE, "< $input_file");
while(<FILE>){
	if(/node\s*\[([^\]]*)\];/){
		my $option = $1;
		$option = $1 if ( $option =~ /size\s*=\s*"?(\d*)"?/);
		$default_size_node = $option;
	}elsif (/edge\s*\[([^\]]*)\];/){
		my $option = $1;
		$option = $1 if ( $option =~ /size\s*=\s*"?(\d*)"?/);
		$default_size_edge = $option;
	}elsif (/^\s*([^ -]*)\s*(\[([^\]]*)\])?;/){
		my $option = $3;
		my $target1 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$option = 1 unless defined $option;
		$option = $1 if ( $option =~ /size\s*=\s*"?(\d*)"?/);
		$cost_node{$target1} = $option;
		$nodes{$target1} = 0;
	}

	if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
		my $option = $4;
		$option = 1 unless defined $option;
		my $target1 = $2;
		my $target2 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$target2 = $1 if($target2 =~ /^"(.*)"$/);
		$option = $1 if ( $option =~ /size\s*=\s*"?(\d*)"?/);
		$cost_edge{$target1.$target2} = $option;
		#$edge{$target1} = {} unless defined $edge{$target1};
		#$edge_reverse{$target2} = {} unless defined $edge_reverse{$target2};
		push @{$edge{$target1}}, $target2;
		push @{$edge_reverse{$target2}}, $target1;
		$nodes{$target1} = 0;
		$nodes{$target2} = 0;
	}
}
close(FILE);

if(not defined $default_size_node){
	print " the default value for node is now : \n"
}

if(not defined $default_size_edge){
	print " the default value for edge is now : \n"
}
	my $start_lp_node;
	my $lp = 0;
	my $max = 0;
	my $tmp = 0;
	my $W = 0;
	my $W_cost = 0;
foreach $n (keys %nodes){
	$tmp = 0;
	$tmp = calcul_recursive($n) unless defined $edge_reverse{$_}; 	
	if ($tmp > $max){
		$max = $tmp; 
		$start_lp_node = $n;
	}
	$W++;
	my $size = $default_size_node;
	$size = $cost_node{$n} if defined $cost_node{$n};
	$W_cost += $size;
}
	$lp += $max;
print " nb node : $W work : $W_cost longest path : $lp\n";
print " longest path : ";
my $tmp_node = $start_lp_node;
my $cost = $default_size_node;
my $nb_node_lp = 1;
$cost = $cost_node{$tmp_node} if defined $cost_node{$tmp_node};
print $tmp_node."\t".$cost."\t";
while( defined $lp_nodes{$tmp_node} ){
	my $tmp_node1=$lp_nodes{$tmp_node};
	my $cost_ed = $cost_edge{$tmp_node.$tmp_node1}; 
	print " cost comm : $cost_ed \t";
	$tmp_node = $tmp_node1;
	$cost = $default_size_node;
	$cost = $cost_node{$tmp_node} if defined $cost_node{$tmp_node};
	print $tmp_node."\t".$cost."\t";
	$nb_node_lp++;
}
print "\n number of node on lp : $nb_node_lp\n";

