#!/usr/bin/perl
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $output_file = $ARGV[1];

my %cost_edge;
my %cost_edge_option;
my %cost_node;
my $nodes=0;
my $edges=0;

open( FILE, "< $input_file");

while(<FILE>){
	if(/node\s*\[([^\]]*)\];/){
		$default_size_node = $1;
	}elsif (/edge\s*\[([^\]]*)\];/){
		$default_size_edge = $1;
	}elsif (/^\s*([^ -]+)\s*(\[([^\]]*)\])?;/){
		my $option = $3;
		my $target1 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$target1++;
		$option = 1 unless defined $option;
		$cost_node{$target1}  = $option;
		$cost_edge{$target1} = [];
		$nodes++;
	}

	if (/(\S+)\s*->\s*(\S+)\s*(\[([^\]]*)\])?;/){
		my $option = $4;
		$option = 1 unless defined $option;
		my $target1 = $2 ;
		my $target2 = $1 ;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$target2 = $1 if($target2 =~ /^"(.*)"$/);
		$target1++;
		$target2++;
#		$cost_edge_option{$target1.$target2}=$option;
		$cost_edge_option{$target2.$target1}=$option;
		push @{$cost_edge{$target2}}, $target1; 
		$edges++;
	}
}
close(FILE);

open( FILE, "> $output_file");
print FILE $nodes."\n";
my $i;
for ($i=1;$i<=$nodes;$i++){
	my $j = $i - 1;
	if($cost_node{$i} =~ /id\s*=\s*"?(\d+)/){
		$j = $1;
  }
  if($cost_node{$i} =~ /size\s*=\s*"(\d+)(\.\d+)?"/){
	  my $cost = int($1/3200000);
	  print FILE $i." ".$cost." ".$j."\n" 
  }  
foreach (@{$cost_edge{$i}}){
	if($cost_edge_option{$i.$_} =~ /size\s*=\s*"(\d+)(\.\d+)?"/){
		my $cost = int($1/125000);
		print FILE $_." ".$cost." " 
	}
}
print FILE "-1 \n";
}
close(FILE);
