#!/usr/bin/perl
use strict;
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $output_file = $ARGV[1];
my $nb_node = $ARGV[2];

my %edge_reverse;
my %nodes;
my %cost_edge;
my %edge;
my %cost_node;

sub Distance {
	my $node1 = shift;
	my $node2 = shift;
	return 0 if ( $node1 =~ $node2);
	my  $distance = 1;
	my %seen_node1;		
	my %seen_node2;		
	my @current_nodes1;		
	my @current_nodes2;		
	my @future_nodes1;		
	my @future_nodes2;
	push @current_nodes1, $node1;
	push @current_nodes2, $node2;
	while (1){
		my $c_node;
		my $c_e;
		foreach $c_node (@current_nodes1){
			foreach $c_e (@{$edge_reverse{$c_node}}){
				return $distance if defined $seen_node2{$c_e};
				push @future_nodes1,$c_e;
				$seen_node1{$c_e} = 1;	
			}
		}
		foreach $c_node (@current_nodes2){
			foreach $c_e (@{$edge_reverse{$c_node}}){
				return $distance if defined $seen_node1{$c_e};
				push @future_nodes2,$c_e;
				$seen_node2{$c_e} = 1;	
			}
		}
		$distance++;
		@current_nodes1 = ();
		@current_nodes2 = ();
		push @current_nodes1, $_ foreach (@future_nodes1);
		push @current_nodes2, $_ foreach (@future_nodes2);
		@future_nodes1 = ();
		@future_nodes2 = ();
	}
}

open( FILE, "< $input_file");

while(<FILE>){
	if(/node\s*\[([^\]]*)\];/){
		$default_size_node = $1;
	}elsif (/edge\s*\[([^\]]*)\];/){
		$default_size_edge = $1;
	}elsif (/^\s*([^ -]*)\s*(\[([^\]]*)\])?;/){
		my $option = $3;
		my $target1 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$option = 1 unless defined $option;
		$cost_node{"\"".$target1."\""} = $option;
	}

	if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
		my $option = $4;
		$option = 1 unless defined $option;
		my $target1 = $1;
		my $target2 = $2;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$target2 = $1 if($target2 =~ /^"(.*)"$/);
		push @{$edge{$target2}}, $target1;
		push @{$edge_reverse{$target1}}, $target2;
		$cost_edge{"\"".$target1."\" -> \"".$target2."\""} = $option;
		$nodes{$target1} = 0;
		$nodes{$target2} = 0;
	}
}
close(FILE);

if(not defined $default_size_node){
	print " the default value for node is now : \n"
}
if(not defined $default_size_edge){
	print " the default value for edge is now : \n"
}
my %distances;
my @length;
my $max=0;
my $n1;
foreach $n1 (keys %nodes){
	next if defined $edge{$n1};
	my $n2;
	foreach $n2 (keys %nodes){
		next if defined $edge{$n2};
		next if (defined $distances{$n1."[]".$n2} or defined $distances{$n2."[]".$n1} );
		$distances{$n1."[]".$n2} = Distance($n1,$n2);
		my $loc = $distances{$n1."[]".$n2};
		$distances{$n2."[]".$n1} = $distances{$n1."[]".$n2};
		if( $distances{$n1."[]".$n2}>$max){
			$max = $distances{$n1."[]".$n2};
		}
		push @{$length[$distances{$n1."[]".$n2}]}, $n1."[]".$n2;
	}
}
my %task_place;
my @place;
my $nb_place_task = 0;
my $i;
for($i=$max;$i>0;$i--){
	last if ($nb_place_task >= $nb_node) ;
	my $tasks;
	foreach $tasks (@{$length[$i]}){
		my $task1;
		my $task2;
		if($tasks=~/([^\[\]]*)\[\]([^\[\]]*)/){
			$task1 = "\"".$1."\"";
			$task2 = "\"".$2."\"";
		}
		if ( not defined $task_place{$task1}){
			$cost_node{$task1} = $cost_node{$task1}.", id = $nb_place_task" 
				if(defined $cost_node{$task1} and $cost_node{$task1} != 1);
			$cost_node{$task1} = "id = $nb_place_task" if(not defined $cost_node{$task1} or $cost_node{$task1} == 1);
			push @{$place[$nb_place_task]}, $task1;
			foreach $tasks (@{$length[1]}){
				my $task11;
				my $task21;
				if($tasks=~/([^\[\]]*)\[\]([^\[\]]*)/){
					$task11 = "\"".$1."\"";
					$task21 = "\"".$2."\"";
				}
				if ( $task11 =~ $task1){
					next if(defined $task_place{$task21});
					$cost_node{$task21} = $cost_node{$task21}.", id = $nb_place_task" 
					if(defined $cost_node{$task21} and $cost_node{$task21} != 1);
					$cost_node{$task21} = "id = $nb_place_task" if(not defined $cost_node{$task21} or  $cost_node{$task21} == 1);
					push @{$place[$nb_place_task]}, $task21;
					$task_place{$task21}=1;
				}
				elsif (	$task21 =~ $task1){
					next if(defined $task_place{$task11});
					$cost_node{$task11} = $cost_node{$task11}.", id = $nb_place_task" 
						if(defined $cost_node{$task11} and $cost_node{$task11} != 1);
					$cost_node{$task11} = "id = $nb_place_task" if(not defined $cost_node{$task11} or  $cost_node{$task11} == 1);
					push @{$place[$nb_place_task]}, $task11;
					$task_place{$task11}=1;
				}

			}
			$nb_place_task++;
			$task_place{$task1}=1;
		}
		last if ($nb_place_task >= $nb_node);
	  next if (	defined $task_place{$task2}) ;
			
		$cost_node{$task2} = $cost_node{$task2}.", id = $nb_place_task" 
			if(defined $cost_node{$task2} and $cost_node{$task2} != 1);
		$cost_node{$task2} = "id = $nb_place_task" if(not defined $cost_node{$task2} or  $cost_node{$task2} == 1);
		push @{$place[$nb_place_task]}, $task2;
		foreach $tasks (@{$length[1]}){
			my $task11;
			my $task21;
			if($tasks=~/([^\[\]]*)\[\]([^\[\]]*)/){
				$task11 = "\"".$1."\"";
				$task21 = "\"".$2."\"";
			}
			if ( $task11 =~ $task2){
				next if(defined $task_place{$task21});
				$cost_node{$task21} = $cost_node{$task21}.", id = $nb_place_task" 
					if(defined $cost_node{$task21} and $cost_node{$task21} != 1);
				$cost_node{$task21} = "id = $nb_place_task" if(not defined $cost_node{$task21} or  $cost_node{$task21} == 1);
				push @{$place[$nb_place_task]}, $task21;
				$task_place{$task21}=1;
			}
			elsif (	$task21 =~ $task2){
				next if(defined $task_place{$task11});
				$cost_node{$task11} = $cost_node{$task11}.", id = $nb_place_task" 
					if(defined $cost_node{$task11} and $cost_node{$task11} != 1);
				$cost_node{$task11} = "id = $nb_place_task" if(not defined $cost_node{$task11} or  $cost_node{$task11} == 1);
				push @{$place[$nb_place_task]}, $task11;
				$task_place{$task11}=1;
			}

		}
		$nb_place_task++;
		$task_place{$task2}=1;
		last if ($nb_place_task >= $nb_node);
	}
}
my $n;
foreach $n (keys %nodes){
	next if(defined $task_place{"\"".$n."\""});
	next if defined $edge{$n};
  my $id;
	my $id_max = $max + 1;	
	my $i = 0;
	for ($i = 0;$i < $nb_node;$i++){
		my $local_max = 0;
		foreach (@{$place[$i]}){
			$local_max = $distances{$n."[]".$_}
		 		if ($distances{$n."[]".$_} > $local_max);
		}
		if ($local_max ==  $id_max){
			$id = $i if (scalar @{$place[$i]} < scalar @{$place[$id]});
		}
		if ($local_max <  $id_max){
			$id = $i;
			$id_max = $local_max;
		}
	}
	my $task_c= "\"".$n."\"";
	$cost_node{$task_c} = $cost_node{$task_c}.", id = $id" 
		if(defined $cost_node{$task_c} and $cost_node{$task_c} != 1);
	$cost_node{$task_c} = "id = $id" if(not defined $cost_node{$task_c} or $cost_node{$task_c} == 1);
		push @{$place[$id]}, $n;
		$task_place{$task_c}=1;
}

open( FILE, "> $output_file");
print FILE "digraph g {\n";
print FILE "\t node [$default_size_node, id = 0]; \n" unless (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t node [id = 0]; \n" if (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t edge [$default_size_edge]; \n";
my @keys = keys %cost_node;
my $key;
foreach $key (@keys){
	my $option = $cost_node{$key};
	print FILE "\t $key [$option]; \n" if ($option != 1);
	print FILE "\t $key; \n" unless ($option != 1);
}
foreach $key (keys %cost_edge){
	my $option = $cost_edge{$key};
	print FILE "\t $key [$option]; \n" if ($option != 1);
	print FILE "\t $key; \n" unless ($option != 1);
}
print FILE "}";
close(FILE);
