#!/usr/bin/perl
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $output_file = $ARGV[1];

my %cost_edge;
my %cost_node;

open( FILE, "< $input_file");

while(<FILE>){
	if(/node\s*\[([^\]]*)\];/){
		$default_size_node = $1;
	}elsif (/edge\s*\[([^\]]*)\];/){
		$default_size_edge = $1;
	}elsif (/^\s*(\S*)\s*(\[([^\]]*)\])?;/){
		my $option = $3;
		my $target1 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$option = 1 unless defined $option;
		$cost_node{"\"task_".$target1."\""} = $option;
	}

	if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
		my $option = $4;
		$option = 1 unless defined $option;
		my $target1 = $2;
		my $target2 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$target2 = $1 if($target2 =~ /^"(.*)"$/);
		$cost_edge{"\"task_".$target1."\" -> \""."task_".$target2."\""} = $option;
	}
}
close(FILE);

if(not defined $default_size_node){
	print " the default value for node is now : \n"
}
if(not defined $default_size_edge){
	print " the default value for edge is now : \n"
}

open( FILE, "> $output_file");
print FILE "digraph g {\n";
print FILE "\t node [$default_size_node]; \n";
print FILE "\t edge [$default_size_edge]; \n";
my @keys = keys %cost_node;
my $key;
foreach $key (@keys){
	my $option = $cost_node{$key};
	print FILE "\t $key [$option]; \n" if ($option != 1);
	print FILE "\t $key; \n" unless ($option != 1);
}
foreach $key (keys %cost_edge){
	my $option = $cost_edge{$key};
	print FILE "\t $key [$option]; \n" if ($option != 1);
	print FILE "\t $key; \n" unless ($option != 1);
}
print FILE "}";
close(FILE);
