#!/usr/bin/perl
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_dot_file = $ARGV[0];
my $input_sim_file = $ARGV[1];
my $output_file = $ARGV[2];
my @color = ("","blue","","","","","","green","","","","","","orange","","","","","","antiquewhite","aliceblue","antiquewhite","antiquewhite3","antiquewhite4","aquamarine","aquamarine3","aquamarine4","azure","azure3","azure4","beige","bisque","bisque1","bisque2","bisque3","bisque4","blanchedalmond","blue1","blue4","blueviolet","brown","brown3","brown4","burlywood","burlywood3","burlywood4","cadetblue1","cadetblue3","cadetblue4","chartreuse","chartreuse3","chartreuse4","chocolate","chocolate3","chocolate4","coral","coral4","cornflowerblue","cornsilk","cornsilk3","cornsilk4","crimson","cyan1","cyan3","cyan4","darkgoldenrod1","darkgoldenrod3","darkgoldenrod4","darkkhaki","darkolivegreen1","darkolivegreen4","darkorange","darkorange1","darkorange4","darkorchid1","darkorchid4","darksalmon","darkseagreen","darkseagreen4","darkslateblue","darkslategray3","darkslategray4","darkturquoise","darkviolet","deeppink","deeppink1","deeppink3","deeppink4","deepskyblue","deepskyblue3","deepskyblue4","dodgerblue","dodgerblue3","dodgerblue4","firebrick","firebrick1","firebrick3","firebrick4","forestgreen","gainsboro","ghostwhite","gold1","gold4","goldenrod");
# fisher_yates_shuffle( \@array ) : generate a random permutation
# of @array in place
sub fisher_yates_shuffle {
	my $array = shift;
	my $i;
	for ($i = @$array; --$i; ) {
		my $j = int rand ($i+1);
		next if $i == $j;
		@$array[$i,$j] = @$array[$j,$i];
	}
}

my %cost_edge;
my %cost_node;

open( FILE, "< $input_dot_file");

while(<FILE>){
	if(/node\s*\[([^\]]*)\];/){
		$default_size_node = $1.", style=filled" if ( $1 =~ /\S/) ;
		$default_size_node = "style=filled" unless ( $1 =~ /\S/) ;
	}elsif (/edge\s*\[([^\]]*)\];/){
		$default_size_edge = $1;
	}elsif (/^\s*([^ -]*)\s*(\[([^\]]*)\])?;/){
		my $option = $3;
		my $target1 = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$option = 1 unless defined $option;
		$cost_node{"\"".$target1."\""} = $option;
	}

	if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
		my $option = $4;
		$option = 1 unless defined $option;
		my $target1 = $1;
		my $target2 = $2;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		$target2 = $1 if($target2 =~ /^"(.*)"$/);
		$cost_edge{"\"".$target1."\" -> \"".$target2."\""} = $option;
	}
}
close(FILE);

if(not defined $default_size_node){
	print " the default value for node is now : \n";
		$default_size_node = "style=filled";
}
if(not defined $default_size_edge){
	print " the default value for edge is now : \n";
}

#fisher_yates_shuffle( \@color );    # permutes @array in place
my %process_task;
open( FILE, "< $input_sim_file");
while(<FILE>){
	if(/\[([^:]*).*\((\d+)\).*Processing\s(\S*)/){
		my $target1 = $3;
		my $col = $color[$2]; 
		my $proc = $1;
		$target1 = $1 if($target1 =~ /^"(.*)"$/);
		next if ($target1 =~ "request");
		$cost_node{$proc} = "color=$col";
	  $target1 = "\"$target1\"";
		my $option = $cost_node{$target1};
		$option =$option.", color=$col" if (defined $option and $option !=1);
		$option ="color=$col" unless ( defined $option and $option != 1);
		warn "ERROR : the task $target1 has been executed severals time" if ($process_task{$target1}  and $target1 !~ /NO_Task/);
		$process_task{$target1} = 1;
		$cost_node{$target1} = $option;
	}
	if(/push_task placement\s*:\s*(\S*)\s*task\s*:\s*(\S*)\s*id\s*:\s(\d+)/){
			my $col = $color[$3*3+1];
			my $target = $2;
			$target =~ s/task/fork/;
			my $option = $cost_node{$target};
			$option =$option.", color=$col" if (defined $option and $option !=1);
			$option ="color=$col" unless ( defined $option and $option != 1);
			warn "ERROR : the task $target1 has been executed severals time" if (defined $cost_node{$target1} and $cost_node{$target1} =~ /color/ and $target1 !~ /NO_Task/);
			$cost_node{$target} = $option;
		}
}
close(FILE);

open( FILE, "> $output_file");
print FILE "digraph g {\n";
print FILE "\t node [$default_size_node]; \n";
print FILE "\t edge [$default_size_edge]; \n";
my @keys = keys %cost_node;
my $key;
foreach $key (@keys){
	my $option = $cost_node{$key};
	print FILE "\t $key [$option]; \n" if ($option != 1);
	print FILE "\t $key; \n" unless ($option != 1);
}
foreach $key (keys %cost_edge){
	my $option = $cost_edge{$key};
	print FILE "\t $key [$option]; \n" if ($option != 1);
	print FILE "\t $key; \n" unless ($option != 1);
}
print FILE "}";
close(FILE);
