#!/usr/bin/env perl

#TODO: add a check that dmake is same version as DMake.pm
#TODO: la doc de la ligne de commande est incompréhensible
#TODO: vérifier que les modules utilisés sont bien là

use strict;
use warnings;
use Getopt::Long;
BEGIN {
	die "DMake.pm not found, check your PERLLIB variable !" unless eval "require DMake";
}

sub help() {
	print <<END;
Usage :
	$0 [ options ] [target] ...

		dmake currently supports the following options : 
		-d : print debugging information.
		-f file : Read FILE as a makefile.
		-p : print dependencies.
		-no-result : don't print the result of tasks.
		-clean : remove all file created by dmake 
						( result.html, result.png, result.dot, all stderr and all stdout)
		-h : Print this message.
END
		exit(0);
}

#some global variables which are accessed in many part of the codes
use vars qw($debug);
$debug = 0;
use vars qw($no_result);
$no_result = 0;

#some arguments we can have
#ID of current process
my $process_id;
#Makefile to use
my $makefile;
#target to generate
my $target;
my $print = 0;
my $tree = 0;
my $clean = 0;
my $check_time = 0;
my $dht = 0;

my $result = GetOptions("d" => \$debug, 
		"p" => \$print,
		"no-result" => \$no_result,
		"tree" => \$tree,
		"no-dht" => \$dht,
		"id=i" => \$process_id,
		"f=s" => \$makefile, 
		"clean" => \$clean,
		"check" => \$check_time,
		"help" => \&help
		);

help() unless $result;

#the first argument without option is used as the target
$target = $ARGV[0] if $ARGV[0];

if ($tree and $dht) {
	$dht = "NoDht";
} else {
	$dht = undef;
}

$makefile = 'Makefile' if not defined $makefile;
die "makefile '$makefile' not found" unless -f $makefile;

my $global_state = new DMake($makefile, $target, $process_id, $tree, $print, $clean, $check_time, $dht);

