#!/usr/bin/perl
use strict;
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $input_placement = $ARGV[1];
my $output_file = $ARGV[2];

my %cost_edge;
my %cost_node;


open( FILE, "< $input_file");

while(<FILE>){
  if(/node\s*\[([^\]]*)\];/){
    $default_size_node = $1;
  }elsif (/edge\s*\[([^\]]*)\];/){
    $default_size_edge = $1;
  }elsif (/^\s*([^ -]*)\s*(\[([^\]]*)\])?;/){
    my $option = $3;
    my $target1 = $1;
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $target1 = $1 if($target1 =~ /(\d+)/);
    $option = 1 unless defined $option;
    $cost_node{"\"".$target1."\""} = $option;
#    print $target1." ".$option."\n";
  }

  if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
    my $option = $4;
    $option = 1 unless defined $option;
    my $target1 = $1;
    my $target2 = $2;
    $target1 = $1 if($target1 =~ /(\d+)/);
    $target2 = $1 if($target2 =~ /(\d+)/);
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $target2 = $1 if($target2 =~ /^"(.*)"$/);
    $cost_edge{"\"".$target1."\" -> \"".$target2."\""} = $option;
  }
}
close(FILE);

if(not defined $default_size_node){
  print " the default value for node is now : \n"
}
if(not defined $default_size_edge){
  print " the default value for edge is now : \n"
}
my %distances;
my @length;
my $max=0;
my $n1;
my %task_place;
my @place;
my $nb_place_task = 0;
my $i;
my $n = 0;
my $option;
my @last_nodes;
my $last_node;
open( FILE, "< $input_placement");

		my $order = 1;
    $n = "root";
    $option = $cost_node{"\"".$n."\""};
    $cost_node{"\"".$n."\""} = "performer = \"0\", order = \"$order\", $option" if defined $option;
    $cost_node{"\"".$n."\""} = "performer = \"0\", order = \"$order\"" unless defined $option;
    $option = $cost_node{"\"".$n."\""};
    $last_nodes[0] = $order + 1;

while(<FILE>){
  if(/^(\d+)\s+(\d+)/){
	print $_;
		my $order = 1;
    $n = $1 - 1;
		$order =  $last_nodes[$2] if (defined  $last_nodes[$2]);
    $option = $cost_node{"\"".$n."\""};
    chomp;
    $cost_node{"\"".$n."\""} = "performer = \"$2\", order = \"$order\", $option" if defined $option;
    $cost_node{"\"".$n."\""} = "performer = \"$2\", order = \"$order\"" unless defined $option;
    $option = $cost_node{"\"".$n."\""};
    $last_nodes[$2] = $order + 1;
		$last_node=$2;
  }
}
close(FILE);
		my $order = 1;
    $n = "end";
		$order =  $last_nodes[$last_node];
    $option = $cost_node{"\"".$n."\""};
    $cost_node{"\"".$n."\""} = "performer = \"0\", order = \"$order\", $option" if defined $option;
    $cost_node{"\"".$n."\""} = "performer = \"0\", order = \"$order\"" unless defined $option;
    $option = $cost_node{"\"".$n."\""};
    print $n." ".$option." \n";
    $last_nodes[$last_node] = $order + 1;



open( FILE, "> $output_file");
print FILE "digraph g {\n";
print FILE "\t node [$default_size_node, id = 0]; \n" unless (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t node [id = 0]; \n" if (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t edge [$default_size_edge]; \n";
my @keys = keys %cost_node;
my $key;
foreach $key (@keys){
  my $option = $cost_node{$key};
  print FILE "\t $key [$option]; \n" if ($option != 1);
  print FILE "\t $key; \n" unless ($option != 1);
}
foreach $key (keys %cost_edge){
  my $option = $cost_edge{$key};
  print FILE "\t $key [$option]; \n" if ($option != 1);
  print FILE "\t $key; \n" unless ($option != 1);
}
print FILE "}";
close(FILE);
