#!/usr/bin/perl
use strict;
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $input_placement = $ARGV[1];
my $output_file = $ARGV[2];

my %edge_reverse;
my %nodes;
my %cost_edge;
my %edge;
my %cost_node;


open( FILE, "< $input_file");

while(<FILE>){
  if(/node\s*\[([^\]]*)\];/){
    $default_size_node = $1;
  }elsif (/edge\s*\[([^\]]*)\];/){
    $default_size_edge = $1;
  }elsif (/^\s*([^ -]*)\s*(\[([^\]]*)\])?;/){
    my $option = $3;
    my $target1 = $1;
    print $target1."\n";
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $target1++;
    $option = 1 unless defined $option;
    $cost_node{"\"".$target1."\""} = $option;
  }

  if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
    my $option = $4;
    $option = 1 unless defined $option;
    my $target1 = $1;
    my $target2 = $2;
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $target2 = $1 if($target2 =~ /^"(.*)"$/);
    $target1++;
    $target2++;
    push @{$edge{$target2}}, $target1;
    push @{$edge_reverse{$target1}}, $target2;
    $cost_edge{"\"".$target1."\" -> \"".$target2."\""} = $option;
    $nodes{$target1} = 0;
    $nodes{$target2} = 0;
  }
}
close(FILE);

if(not defined $default_size_node){
  print " the default value for node is now : \n"
}
if(not defined $default_size_edge){
  print " the default value for edge is now : \n"
}
my %distances;
my @length;
my $max=0;
my $n1;
my %task_place;
my @place;
my $nb_place_task = 0;
my $i;
my $n = 0;
my $option;
open( FILE, "< $input_placement");

while(<FILE>){
  if(/(\d*)\s*(\d*)\s*\d*\s*\d*/){
    $n = $1;
    $option = $cost_node{"\"".$n."\""};
    print $n." ".$option." \n";
    chomp;
    $cost_node{"\"".$n."\""} = "$option, id = $2";
    $option = $cost_node{"\"".$n."\""};
    print $n." ".$option." \n";
  }
}
close(FILE);

my %cost_metis_edge;
my %cost_metis_node;

my @keys = keys %cost_node;
my $key;
foreach $key (@keys){
  my $option = $cost_node{$key};
  my $size; 
  my $id;
  $size=$1 if ($option =~ /size\s*[=:]\s*"(\d+)/);
  $size=int($size / 1000000);
  $id=$1 if ($option =~ /id\s*[=:]\s*(\d+)/);
  next unless defined $id;
  if (defined $cost_metis_node{$id}){
    $cost_metis_node{$id} = $size;
  }else{
    $cost_metis_node{$id} += $size;
  }
}
foreach $key (keys %cost_edge){
  my $option = $cost_edge{$key};
  print $key." ".$option."\n"; 
  my $size;
  $size=$1 if ($option =~ /size\s*[=:]\s*"(\d+)/);
  $size=int($size / 1250);
  if($key =~/"(.*)"\s*->\s*"(.*)"/){
    my $target1 = $1;
    my $target2 = $2;
    if($cost_node{"\"".$target1."\""} =~ /id\s*=\s*(\d+)/){
      $target1=$1;
    }
    if($cost_node{"\"".$target2."\""} =~ /id\s*=\s*(\d+)/){
      $target2=$1;
    }
    if ($target2 != $target1){
      if (defined $cost_metis_edge{"\"".$target1."\" -> \"".$target2."\""}){
        $cost_metis_edge{"\"".$target1."\" -> \"".$target2."\""} = $size;
      }else{
        $cost_metis_edge{"\"".$target1."\" -> \"".$target2."\""} += $size;
      }
    }
  }
}


open( FILE, "> $output_file");
print FILE "digraph g {\n";
print FILE "\t node [$default_size_node, id = 0]; \n" unless (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t node [id = 0]; \n" if (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t edge [$default_size_edge]; \n";
my @keys = keys %cost_metis_node;
my $key;
foreach $key (@keys){
  my $option = "size = \"".$cost_metis_node{$key}."\"";
  print FILE "\t \"$key\" [$option]; \n" if ($option != 1);
  print FILE "\t $key; \n" unless ($option != 1);
}
foreach $key (keys %cost_metis_edge){
  my $option = "size = \"".$cost_metis_edge{$key}."\"";
  print FILE "\t $key [$option]; \n" if ($option != 1);
  print FILE "\t $key; \n" unless ($option != 1);
}
print FILE "}";
close(FILE);
