#!/usr/bin/perl
use strict;
my $default_size_node = undef;
my $default_size_edge = undef;
my $input_file = $ARGV[0];
my $input_placement = $ARGV[1];
my $output_file = $ARGV[2];

my %cost_edge;
my %cost_node;


open( FILE, "< $input_file");

while(<FILE>){
  if(/node\s*\[([^\]]*)\];/){
    $default_size_node = $1;
  }elsif (/edge\s*\[([^\]]*)\];/){
    $default_size_edge = $1;
  }elsif (/^\s*([^ -]*)\s*(\[([^\]]*)\])?;/){
    my $option = $3;
    my $target1 = $1;
    print $target1."\n";
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $option = 1 unless defined $option;
    $cost_node{"\"".$target1."\""} = $option;
  }

  if (/(\S*)\s*->\s*(\S*)\s*(\[([^\]]*)\])?;/){
    my $option = $4;
    $option = 1 unless defined $option;
    my $target1 = $1;
    my $target2 = $2;
    $target1 = $1 if($target1 =~ /^"(.*)"$/);
    $target2 = $1 if($target2 =~ /^"(.*)"$/);
    $cost_edge{"\"".$target1."\" -> \"".$target2."\""} = $option;
  }
}
close(FILE);

if(not defined $default_size_node){
  print " the default value for node is now : \n";
}
if(not defined $default_size_edge){
  print " the default value for edge is now : \n";
}
my %distances;
my @length;
my $max=0;
my $n1;
my %task_place;
my @place;
my $nb_place_task = 0;
my $i;
my $n = 0;
my $option;
my %place;
open( FILE, "< $input_placement");

while(<FILE>){
  chomp;
  $place{$n} = $_;
  $n++;
}
close(FILE);



open( FILE, "> $output_file");
print FILE "digraph g {\n";
print FILE "\t node [$default_size_node, id = 0]; \n" unless (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t node [id = 0]; \n" if (not defined $default_size_node or $default_size_node =~ /\s*/);
print FILE "\t edge [$default_size_edge]; \n";
my @keys = keys %cost_node;
my $key;
foreach $key (@keys){
  my $option = $cost_node{$key};
  if ($option =~ /id\s*[=:]\s*(\d+)/){
    my $place = $place{$1};
    print "placement $1 ".$place."\n";
    $option =~ s/id\s*[=:]\s*\d+/id = $place/;
  }else{
    warn "id not found $key";
  }
  print FILE "\t $key [$option]; \n" if ($option != 1);
  print FILE "\t $key; \n" unless ($option != 1);
}
foreach $key (keys %cost_edge){
  my $option = $cost_edge{$key};
  print FILE "\t $key [$option]; \n" if ($option != 1);
  print FILE "\t $key; \n" unless ($option != 1);
}
print FILE "}";
close(FILE);
