#include "type_data.h"
#include <stdio.h>
#include "stack.h"
XBT_LOG_EXTERNAL_DEFAULT_CATEGORY(m);
/** operations on the stack of tasks */
void push_task(int id, m_task_t task){
  stacks[id].work_stack += MSG_task_get_compute_duration(task);
  PushBack(&stacks[id], (void*) task);
}

long double get_sizable_work(int id){
  return stacks[id].work_stack;
}

m_task_t pop_task(int id){
  elem * tmp = GetBack(&stacks[id]);
  m_task_t task;
  while(tmp != NULL && !is_steal_ready(tmp->value)){
    task = tmp->value;
    tmp=tmp->prev;
  }
  if (tmp == NULL)
    return NULL;
  task = tmp->value;
  Remove(&stacks[id],tmp);
  stacks[id].work_stack -= MSG_task_get_compute_duration(task);
  return task;
}

void View1(int id){
  elem * tmp = GetBack(&stacks[id]);
  m_task_t task;
  while(tmp != NULL){
    fprintf(stderr,"iname task in stack : %s\n",MSG_task_get_name(tmp->value));
    task = tmp->value;
    tmp=tmp->prev;
  }
  return;
}

m_task_t steal_task(int id){
//  XBT_INFO(" test steal ONE task");
  elem * tmp = GetFront(&stacks[id]);
  if (tmp == NULL)
    return NULL;
  Agnode_t *dag_node = MSG_task_get_data(tmp->value);
//  XBT_INFO(" test steal a task");
  while(tmp!=NULL && 
#ifdef FORK
        (!test_string(agnameof(dag_node),"fork",4))
#else
        ( !is_steal_ready(tmp->value) || !((mynode*)(AGDATA(dag_node)))->ready)
#endif
       ){
    tmp=tmp->next;
    if(tmp!=NULL)
      dag_node = MSG_task_get_data(tmp->value);
  }
  if (tmp == NULL)
    return NULL;
  m_task_t task = tmp->value;
//  XBT_INFO("steal : %s",agnameof(dag_node));
  Remove(&stacks[id],tmp);
  stacks[id].work_stack -= MSG_task_get_compute_duration(task);
  return task;
}

m_task_t steal_tasks(int id, int thief){
  //XBT_INFO(" test steal several tasks");
  elem * tmp = GetFront(&stacks[id]);
  if (tmp == NULL){
  //  XBT_INFO("no task");
    return NULL;
  }
  Agnode_t *dag_node = MSG_task_get_data(tmp->value);
  int level_min = -1;
  int nb = 0;
  if (((mynode*)(AGDATA(dag_node)))->level != -1){
    if(level_min == ((mynode*)(AGDATA(dag_node)))->level &&
#ifdef FORK
       (test_string(agnameof(dag_node),"fork",4))
#else
       ( is_steal_ready(tmp->value) || ((mynode*)(AGDATA(dag_node)))->ready)
#endif
      ){
      level_min = ((mynode*)(AGDATA(dag_node)))->level;
      nb++;
    }
  }
  tmp=tmp->next;
  while(tmp!=NULL){
    dag_node = MSG_task_get_data(tmp->value);
    if (((mynode*)(AGDATA(dag_node)))->level != -1){
      if ((level_min == -1) &&  
#ifdef FORK
          (test_string(agnameof(dag_node),"fork",4)) 
#else
          ( is_steal_ready(tmp->value) || ((mynode*)(AGDATA(dag_node)))->ready)
#endif
         ){
        level_min = ((mynode*)(AGDATA(dag_node)))->level;
        nb =1;
      }
      if (level_min > ((mynode*)(AGDATA(dag_node)))->level &&
#ifdef FORK
          (test_string(agnameof(dag_node),"fork",4)) 
#else
          ( is_steal_ready(tmp->value) || ((mynode*)(AGDATA(dag_node)))->ready)
#endif
      ){
        level_min = ((mynode*)(AGDATA(dag_node)))->level;
        nb = 1;
      }
      if(level_min == ((mynode*)(AGDATA(dag_node)))->level &&
#ifdef FORK
         (test_string(agnameof(dag_node),"fork",4))
#else
         ( is_steal_ready(tmp->value) || ((mynode*)(AGDATA(dag_node)))->ready)
#endif
        ){
        nb++;
      }
    }
    tmp=tmp->next;
  }
  if (nb == 0) {
   // XBT_INFO("no task nb = 0");
    return NULL;
  }
 // XBT_INFO("nb : %d",nb);
  nb = nb/2;
  if (nb == 0) nb ++;
 // XBT_INFO("nb : %d",nb);
  tmp = GetFront(&stacks[id]);
  elem * ret = NULL;
  while(tmp!=NULL && nb !=0){
    dag_node = MSG_task_get_data(tmp->value);
    if(level_min == ((mynode*)(AGDATA(dag_node)))->level &&
#ifdef FORK
  (test_string(agnameof(dag_node),"fork",4)) ){
#else
      ( is_steal_ready(tmp->value) || ((mynode*)(AGDATA(dag_node)))->ready)){
#endif

      if (ret != NULL){
        m_task_t task = ret->value;
        Remove(&stacks[id],ret);
        stacks[id].work_stack -= MSG_task_get_compute_duration(task);
        push_task(thief, task);
      }
      nb--;
      ret = tmp;
    }

    tmp=tmp->next;
  }
  if (ret == NULL)
    return NULL;
  m_task_t task = ret->value;
  Remove(&stacks[id],ret);
  stacks[id].work_stack -= MSG_task_get_compute_duration(task);
  return task;
}
