#include "type_data.h"
XBT_LOG_NEW_DEFAULT_CATEGORY(m2,
                             "Messages specific for this msg example");
/** test the property of the task */
bool is_fork(m_task_t task);
bool is_data(m_task_t task);
bool is_request(m_task_t task);

bool test_string(char*name_task,char * name_test, int max){
  int i;
  for(i=0; i < max; i++){
    if (name_task[i] != name_test[i])
      return false;
  }
  return true;
}

bool test_name(m_task_t task,char * name_test, int max){
  char name[512];
  int i;
  sprintf(name, "%s", MSG_task_get_name(task));
  for(i=0; i < max; i++){
    if (name[i] != name_test[i])
      return false;
  }
  return true;
}

bool is_fork(m_task_t task){
  return test_name(task, "fork", 4);
}

bool is_data(m_task_t task){
  return test_name(task, "data", 4);
}

bool is_request(m_task_t task){
  return test_name(task, "request", 7);
}



/** test on the state of tasks */
bool is_executed(m_task_t task);
bool is_ready(m_task_t task);
bool is_steal_ready(m_task_t task);
bool is_created(m_task_t task);

bool test_status(m_task_t task, state_t state){
  Agnode_t *dag = MSG_task_get_data(task);
  mynode *node =	(mynode*)(AGDATA(dag));
  return node->state == state;
}

bool is_executed(m_task_t task){
  return test_status(task,FINISHED);
}

bool is_steal_ready(m_task_t task){
  Agnode_t * node  = MSG_task_get_data(task);
  mynode   * state = (mynode*)(AGDATA(node));
  return state->ready;
}

bool is_ready(m_task_t task){
  if(is_fork(task))
    return true;
  bool val = true;

  Agedge_t    *e;
  char* name;
  mynode    *node_require;
  Agnode_t * v = MSG_task_get_data(task);
  for (e = agfstin(dag_dot,v); e; e = agnxtin(dag_dot,e)) {
    Agnode_t * node = agtail(e);
    xbt_assert( node != v, "This is not the wanted node to fork");
    name = agnameof(node);
    node_require = (mynode*)(AGDATA(node));
    if (!test_string(name,"fork",4) && node_require->state != FINISHED)
    {
//XBT_INFO("dependences pour task : %s fail : %s\n", MSG_task_get_name(task), name);
      val =false;
    }
  }
  return val;
}

bool is_created(m_task_t task){
  return test_status(task,CREATED);
}



