#ifndef _TYPE_DATA_H
#define _TYPE_DATA_H
#include "msg/msg.h"            /* Yeah! If you want to use msg, you need to include msg/msg.h */
#include "dblist.h"             /* Doubly-Linked Lists */
#include <graphviz/cgraph.h>
#include "xbt/log.h"            /* Create a log channel to have nice outputs. */
#include "xbt/asserts.h"

//#define light //display only usefull trace
//#define visu // display log for the trace viewer of fred

extern msg_test;

typedef enum
{
  false,
  true
} bool;

/* state stolen or not? */
typedef enum {
  NONE = 0,
  FORKED = 1,
  CREATED = 2,
  STOLEN = 3,
  WAITING = 4,
  RUNNING = 5,
  FINISHED = 6
} state_t;

typedef enum {
  ON0 = 0,
  RR = 1,
  RAND = 2,
  GIVEN = 3,
} placement_t;

typedef enum {
  ONE = 0,
  HALF = 1,
} vol_t;

typedef struct mynode_s {
  Agrec_t hdr;
  m_task_t msg_task;
  int id;
  m_host_t dht;
  char * hostname;
  int level;
  state_t state;
  bool view;
  bool ready;
  bool fork;
} mynode;

typedef struct myedge_s {
  Agrec_t hdr;
  int id;
} myedge;


extern mynode * last_task;
extern bool end_done;
extern dblist *first_nodes;
extern Agraph_t *dag_dot;
extern m_host_t *worker;
extern dblist *stacks;
extern int slaves_count;
typedef enum {
  PORT_21 = 0,
  PORT_22 = 1,
  PORT_23 = 2,
  MAX_CHANNEL
} channel_t;

#define FINALIZE ((void*)221297)        /* a magic number to tell people to stop working */
#define REQUEST ((void*)221207)        /* a magic number to ask a task to a processor */
#define NO_TASK ((void*)221267)        /* a magic number to tell thief that there aren't task here */
#define REQUEST_COST ((int)3)        /* Cost of a request */
#define FORK_COST ((int)3)        /* Cost of a request */
#endif
