#include "type_data.h"
#include <unistd.h>
#include <stdio.h>
#include "xbt/sysdep.h"         /* calloc, printf */
#include <time.h>
#include "stack.h"
#include "steal.h"
XBT_LOG_NEW_DEFAULT_CATEGORY(m,
                             "Messages specific for this msg example");

placement_t placement;
vol_t vol;
bool placement_done = FALSE;
/* Create a log channel to have nice outputs. */
#include "msg/msg.h"            /* Yeah! If you want to use msg, you need to
                                   include msg/msg.h */

mynode * last_task = NULL;
bool end_done = false;
dblist *first_nodes = NULL;
bool fork_state = false;

int push_data(int argc, char *argv[])
{
}
int answer_ready(int argc, char *argv[])
{
  int i;
  mynode * state;
  mynode * state_tmp;
  Agnode_t * dag;
  Agnode_t * dag_tmp;
  m_task_t task, send_task;
  m_task_t task_request;
  int id = intialisation_data( argc,argv);
  m_host_t host = MSG_host_self();
  const char * hostname = MSG_host_get_name(host);
  MSG_error_t res = MSG_TASK_CANCELLED;
  char sprintf_buffer[512];
  char mailbox[64];
#ifndef visu
#ifndef light
  XBT_INFO("hostname : %s", hostname);
#endif
#endif

  while (1) {
    task=NULL;
    sprintf(mailbox, "%s_ready", hostname);
    XBT_INFO("wait a task");
    res = MSG_task_receive(&task, mailbox);
    xbt_assert(res == MSG_OK, "MSG_task_get failed");

    //sprintf_buffer = MSG_task_get_name(task_tmp);
    if (MSG_task_get_data(task) == FINALIZE) {
      MSG_task_destroy(task);
      break;
    }

    m_host_t thief_id = MSG_task_get_source	(task);
    const char * hostname_thief = MSG_host_get_name(thief_id);
    task_request = (m_task_t)MSG_task_get_data(task);
    dag = MSG_task_get_data(task_request);
    state =	(mynode*)(AGDATA(dag));
#ifndef visu
#ifndef light
    XBT_INFO("Received \"%s\" for : \"%s\"", MSG_task_get_name(task),
          MSG_task_get_name(task_request));
#endif
#endif

    if (test_string(task->name,"READY",5)) {
      state->ready = true;
    } else{
      XBT_INFO("Error recieve \"%s\" from \"%s\"", task->name, thief_id->name);
      return 32123;
    }
    //MSG_task_destroy(task);
    task = NULL;
    send_task=NULL;
  }
#ifndef visu
#ifndef light
  XBT_INFO("I'm done. See you!");
#endif
#endif
  return 0;
}
int data_receiver(int argc, char *argv[])
{
}

Agraph_t *dag_dot = NULL;
m_host_t *worker = NULL;
int *stealing = NULL;
dblist *stacks = NULL;
int slaves_count = 0;
bool inti = false;


int execute_task(int argc, char *argv[]);
int answer_request(int argc, char *argv[]);
int data_sender(int argc, char *argv[]);
int DHT(int argc, char *argv[]);
MSG_error_t test_all(const char *platform_file, const char *application_file);


int intialisation_data(int argc, char *argv[]){
  slaves_count = argc - 1;
  XBT_INFO("Start nb slave : %d ", slaves_count);
  int i;
  if( worker == NULL ){                             /* Process organisation */
    worker = xbt_new0(m_host_t, slaves_count);
    stacks = xbt_new0(dblist, slaves_count);
    stealing = xbt_new0(int, slaves_count);

    for (i = 0; i < slaves_count; i++) {
      worker[i] = MSG_get_host_by_name(argv[i+1]);
      stealing[i] = 0;
      Init(&stacks[i]);
      xbt_assert(worker[i] != NULL, "Unknown host %s. i=%d Stopping Now! ",
                  argv[i], i);
    }
	inti=true;
  } else {
	while(!inti) MSG_process_sleep(0);
  }
  for (i = 0; i < slaves_count; i++){
    XBT_DEBUG("%s", worker[i]->name);
    if (MSG_host_self() == worker[i]) {
      return i;
    }
  }
}



/** execute task in the order  */
int execute_task(int argc, char *argv[])
{
  Agnode_t *dag_node   = NULL;
  m_task_t  task_node  = NULL;
  mynode   *state_node = NULL;

  Agnode_t *dag_tmp    = NULL;
  m_task_t  task_tmp   = NULL;
  mynode   *state_tmp  = NULL;
  Agedge_t *edge_tmp   = NULL;

  double inactivity_time = 0;
  double last_active_time = 0;
  long double work_stack = 0;

  MSG_error_t res;
  int i;
  char sprintf_buffer[512];
  char mailbox[64];
  int id = intialisation_data( argc,argv);

  /** TODO: change this for doing transformation on the dag and giving tasks without input edge */
  /** change the rest in function of that */
  /** use dag_transformation may be we want to push free tasks in severals stasks (have to see that)*/
#ifdef DMAKE
  last_active_time =  MSG_get_clock();
  /** scheduling with the algorithm of dmake */
  if (placement_done == false) {
    XBT_INFO("start task placement");
    placement_done=true;
    /** initialize the stack */
    for (dag_tmp = agfstnode(dag_dot); dag_tmp; dag_tmp = agnxtnode(dag_dot,dag_tmp)){
      sprintf(sprintf_buffer, "%s", agnameof(dag_tmp));
      if(test_string(sprintf_buffer,"fork",4)){
        fork_state = true;
        continue;
      }
    }
    int dht_id = 0;
    for (dag_tmp = agfstnode(dag_dot); dag_tmp; dag_tmp = agnxtnode(dag_dot,dag_tmp)){
      state_tmp = (mynode*) agbindrec(dag_tmp,"mynode",sizeof(mynode),3);
      state_tmp->id = -1;
      state_tmp->view = false;
      state_tmp->ready = false;
      state_tmp->level = -1;
      sprintf(sprintf_buffer, "%s", agnameof(dag_tmp));
      if(test_string(sprintf_buffer,"fork",4)) state_tmp->ready = true;
      if (fork_state)
        state_tmp->state = FORKED;
      else
        state_tmp->state = NONE;

    if(!fork_state){
      char *weight = NULL;
      double size = 1;
      if(test_string(sprintf_buffer,"fork",4)){
        size=(int)FORK_COST;
      }else{
        weight = agget(dag_tmp, "size");
        if(weight != NULL)
          size = atof(weight);
        else
          size=1;
      }
      task_tmp = MSG_task_create(sprintf_buffer, size , 0, dag_tmp);
      state_tmp->msg_task = task_tmp;
    }
      state_tmp->hostname = worker[dht_id]->name;
      dht_id++;
      dht_id = dht_id % slaves_count;
    }
    for (dag_tmp = agfstnode(dag_dot); dag_tmp; dag_tmp = agnxtnode(dag_dot,dag_tmp)){
      if (agfstout(dag_dot,dag_tmp)==NULL) break;
    }
    last_task = (mynode*)(AGDATA(dag_tmp));
    int chosen_id = -1;
    //	for (dag_tmp = agfstnode(dag_dot); dag_tmp; dag_tmp = agnxtnode(dag_dot,dag_tmp))
    dblist dag_stack;
    Init(&dag_stack);
    PushBack(&dag_stack, (void*) dag_tmp);
    dag_node = PopBack(&dag_stack);
    sprintf(sprintf_buffer, "%s", agnameof(dag_node));
    while(dag_node != NULL){
      Agedge_t    *e;
      bool ready = true;
      for (e = agfstin(dag_dot,dag_node); e; e = agnxtin(dag_dot,e)) {
        dag_tmp = agtail(e);
        sprintf(sprintf_buffer, "%s", agnameof(dag_tmp));
        state_tmp  = (mynode*)(AGDATA(dag_tmp));
        if(!test_string(sprintf_buffer,"fork",4)){
              ready = false;
        }
        if (state_tmp->view == false ){
          state_tmp->view = true;
          PushBack(&dag_stack, (void*) dag_tmp);
          if (fork_state){
            char *weight = NULL;
            double size = 1;
            if(test_string(sprintf_buffer,"fork",4)){
              size=(int)FORK_COST;
            }else{
              weight = agget(dag_tmp, "size");
              if(weight != NULL)
                size = atof(weight);
              else
                size=1;
            }
            task_tmp = MSG_task_create(sprintf_buffer, size , 0, dag_tmp);
            state_tmp->msg_task = task_tmp;
          }else {
            task_tmp = state_tmp->msg_task; 
          }
          if (agfstin(dag_dot,dag_tmp)==NULL) {
            XBT_INFO("push task");
            state_tmp->ready = true;
            sprintf(sprintf_buffer, "%s", agnameof(dag_tmp));
            char *weight = NULL;
            double size = 1;
            if(test_string(sprintf_buffer,"fork",4)){
              size=(int)FORK_COST;
            }else{
              weight = agget(dag_tmp, "size");
              if(weight != NULL)
                size = atof(weight);
              else
                size=1;
            }
            state_tmp = (mynode*)(AGDATA(dag_tmp));
            state_tmp->id = id;
            state_tmp->level = 0;
            //XBT_INFO("level0");
            //if(fork_state){
            //  task_tmp = MSG_task_create(sprintf_buffer, size , 0, dag_tmp);
            //  state_tmp->msg_task = task_tmp;
            //}
#ifdef TRACE
            if(is_fork(task_tmp)){
              TRACE_msg_set_task_category(task_tmp, "FORK");
            }else{
              TRACE_msg_set_task_category(task_tmp, "TASK");
            }
#endif
            char * c_id;
            switch(placement){
              case ON0 :
                chosen_id = 0;
#ifndef visu
#ifndef light
                XBT_INFO("push_task placement : ON0 task : %s id : %d", sprintf_buffer, chosen_id);
#endif
#endif
                break;
              case RR :
                chosen_id++;
                chosen_id = chosen_id % slaves_count;
#ifndef visu
#ifndef light	
                XBT_INFO("push_task placement : RR task : %s id : %d", sprintf_buffer, chosen_id);
#endif
#endif
                break;
              case RAND :
                chosen_id = rand() % slaves_count;
#ifndef visu
#ifndef light
                XBT_INFO("push_task placement : RAND task : %s id : %d", sprintf_buffer, chosen_id);
#endif
#endif
                break;
              case GIVEN :
                c_id = agget(dag_tmp,"id");
                if (c_id !=NULL ){
                  chosen_id = atoi(c_id);
                }else{
                  chosen_id = 0;
                }
#ifndef visu
#ifndef light
                XBT_INFO("push_task placement : GIVEN task : %s id : %d", sprintf_buffer, chosen_id);
#endif
#endif
                break;
            }
            state_tmp->id = chosen_id;
            state_tmp->ready = true;
            push_task(chosen_id,task_tmp);
          }
        }
        task_tmp = NULL;
        dag_tmp = NULL;
        state_tmp = NULL;
      }
      state_node  = (mynode*)(AGDATA(dag_node));
      state_node->ready = ready;
      dag_node = PopBack(&dag_stack);
    }
    task_tmp = NULL;
    dag_tmp = NULL;
    state_tmp = NULL;
  }
#else
#error "not implemented yet"
  /** scheduling with the classical work-stealing */
  if (id == 0) {
    /** initialize the stack */
    /** put all leaf into the stacks */
    //sprintf(sprintf_buffer, "Task_%d", i);
    //c_task = MSG_task_create(sprintf_buffer, task_comp_size, NULL, NULL);
    //worker[0] = g_list_append (worker[0], c_task);
  }
#endif
  work_stack = stacks[id].work_stack;
#ifdef visu
  XBT_INFO("w %g %d %Lf",MSG_get_clock(), id, work_stack);
#endif

  while(1){
    if(last_task != NULL && last_task->state >= RUNNING)
      goto End;
    do {
      task_node = (m_task_t) pop_task(id);
      if(task_node == NULL) break;
      dag_node = MSG_task_get_data(task_node);
      state_node =	(mynode*)(AGDATA(dag_node));
    } while (( state_node->state >= WAITING ));
    if (task_node != NULL){
#ifndef visu
#ifndef light
      XBT_INFO("Pop \"%s\"", MSG_task_get_name(task_node));
#endif
#endif
      work_stack = stacks[id].work_stack;
#ifdef visu
      XBT_INFO("w %g %d %Lf",MSG_get_clock(), id, work_stack);
#endif
      stealing[id] = 0;
      bool enable_push = true;
      if (!is_fork(task_node)){
        /** ask for data */
#ifndef visu
#ifndef light
        XBT_INFO("State WAITING \"%s\"", MSG_task_get_name(task_node));
#endif
#endif
        state_node->state = WAITING;
        int number_data = 0; /** number of task send to ask data */
        int host_id;
        MSG_error_t res;
        if (last_active_time == 0 ){
          last_active_time =  MSG_get_clock();
        }
        for (edge_tmp = agfstin(dag_dot, dag_node); edge_tmp; edge_tmp = agnxtin(dag_dot, edge_tmp)) {
          dag_tmp = agtail(edge_tmp);
          xbt_assert( dag_tmp != dag_node, "This is not the wanted node to fork");
          char *weight = agget(edge_tmp,"size");
          double *size = malloc(sizeof(double));
          if (weight !=NULL && (*size =atof(weight))!= 0 ){
            sprintf(sprintf_buffer, "data_%s--%s", agnameof(dag_tmp), agnameof(dag_node));
            task_tmp = MSG_task_create(sprintf_buffer, 0, 0,  (void*)size);
#ifdef TRACE
            TRACE_msg_set_task_category(task_tmp, "ASK_DATA");
#endif
            state_tmp = (mynode*)(AGDATA(dag_tmp));
            host_id= state_tmp->id;
            if (host_id != id && !test_string(agnameof(dag_tmp),"fork",4)){
#ifndef visu
              XBT_INFO("Sending \"%s\" to \"%d\" by \"%d\"", task_tmp->name, host_id, id);
#endif
#ifdef visu
              XBT_INFO("d %g %d %d",MSG_get_clock(), host_id, id);
#endif
              sprintf(mailbox, "%s_data", worker[host_id]->name);
              MSG_task_send(task_tmp, mailbox);
              //MSG_task_put(task_tmp, worker[host_id], PORT_21);
#ifndef visu
#ifndef light
              XBT_INFO("Sent");
#endif
#endif
              task_tmp=NULL;
              task_tmp = NULL;
              sprintf(mailbox, "%s_exe", worker[id]->name);
              res = MSG_task_receive(&task_tmp, mailbox);
              xbt_assert(res == MSG_OK, "MSG_task_get failed");
#ifndef visu
#ifndef light
              XBT_INFO("Received \"%s\" by \"%d\"", MSG_task_get_name(task_tmp),id);
#endif
#endif
              /** the task finalize is receive */
              if (MSG_task_get_data(task_tmp) == FINALIZE) {
                //MSG_task_destroy(c_task);
                goto End_d;
              }
              number_data++;
            }
          }
        }
        for(i = 0; i < number_data; i++){
        }
        task_tmp=NULL;
        dag_tmp = NULL;
        state_tmp = NULL;


        /*execution of the task*/
#ifndef visu
#ifndef light
        XBT_INFO("State RUNNING \"%s\"", MSG_task_get_name(task_node));
#endif
#endif
        state_node->state = RUNNING;
        if (last_active_time != 0 ){
          inactivity_time +=  MSG_get_clock() - last_active_time;
#ifdef visu
          XBT_INFO("i %g %d %g",MSG_get_clock(), id, inactivity_time);
#endif
        }
        last_active_time = 0;
#ifndef visu
#ifndef light
        XBT_INFO("Processing \"%s\"", MSG_task_get_name(task_node));
#endif
#endif
        MSG_task_execute(task_node);
#ifndef visu
#ifndef light
        XBT_INFO("\"%s\" done by %d", MSG_task_get_name(task_node),id);
#endif
#endif
#ifdef visu
        XBT_INFO("l %g %d %s_completed",MSG_get_clock(), id, MSG_task_get_name(task_node));
#endif
      }else{

#ifndef visu
#ifndef light
        XBT_INFO("Processing \"%s\"", MSG_task_get_name(task_node));
#endif
#endif
        int count=0;
        for (edge_tmp = agfstin(dag_dot,dag_node); edge_tmp; edge_tmp =
             agnxtin(dag_dot,edge_tmp)) {
          count++;
        }
#ifndef visu
#ifndef light
        XBT_INFO("number of input edge : %d",count);
#endif
#endif
        if (count > 1){
        state_node->state = RUNNING;
        sprintf(sprintf_buffer, "REQ_FORK");
        task_tmp = MSG_task_create(sprintf_buffer, 0, 100, (void*)task_node);
        char * hostname = state_node->hostname;
        sprintf(mailbox, "%s_dht", hostname);
        MSG_task_send(task_tmp, mailbox);
        task_tmp = NULL;
        sprintf(mailbox, "%s_exe", worker[id]->name);
        res = MSG_task_receive(&task_tmp, mailbox);
        enable_push = (bool)MSG_task_get_data(task_tmp);
#ifndef visu
#ifndef light
        XBT_INFO("Received \"%s\" enable_push %d",
              MSG_task_get_name(task_tmp),enable_push);
#endif
#endif
        xbt_assert(res == MSG_OK, "MSG_task_get failed");
        }else{
          enable_push = true;
        }
#ifndef visu
#ifndef light
        XBT_INFO("\"%s\" done", MSG_task_get_name(task_node));
#endif
#endif
#ifdef visu
        XBT_INFO("l %g %d %s_completed",MSG_get_clock(), id, MSG_task_get_name(task_node));
#endif
      }

      /** execute the task and create the command if it is require */
      state_node->state = FINISHED;
      int level = state_node->level + 1;
      //XBT_INFO("level = %d",level);
      dag_node = MSG_task_get_data(task_node);
      Agedge_t    *e;
      for (e = agfstout(dag_dot,dag_node); e; e = agnxtout(dag_dot,e)) {
        dag_tmp = aghead(e);
        xbt_assert(dag_tmp != dag_node, "This is not the wanted node to create");
        state_tmp =	(mynode*)(AGDATA(dag_tmp));
        if (state_tmp->level < level) state_tmp->level = level;
        sprintf(sprintf_buffer, "%s", agnameof(dag_tmp));
        if ( enable_push && ( !fork_state || is_fork(task_node) ) && state_tmp->state < WAITING ){
          if ( is_fork(task_node) ) {
            state_tmp->id = id;
            state_tmp->state = CREATED;
#ifndef visu
#ifndef light
            XBT_INFO("State is_fork(task_node)CREATED \"%s\"", sprintf_buffer);
#endif
#endif
            char *weight = NULL;
            double size = 1;
            if(test_string(sprintf_buffer,"fork",4)){
              size=FORK_COST;
            }else{
              weight = agget(dag_tmp, "size");
              if(weight != NULL)
                size = atof(weight);
              else
                size=1;
            }
            task_tmp = MSG_task_create(sprintf_buffer, size , 0, dag_tmp);
            state_tmp->msg_task = task_tmp;
#ifdef TRACE
            TRACE_msg_set_task_category(task_tmp, "FORK");
#endif
#ifndef visu
#ifndef light
            XBT_INFO("Push \"%s\"", MSG_task_get_name(task_tmp));
#endif
#endif
            push_task(id, task_tmp);
          }else{
            //envoi de DEP et attendre pour savoir si il faut la forker
            task_tmp = state_tmp->msg_task;
            sprintf(sprintf_buffer, "DEP");
            m_task_t task_tmp2 = MSG_task_create(sprintf_buffer, 0, 100,
                                                 task_tmp);
            sprintf(mailbox, "%s_dht", state_tmp->hostname);
            state_tmp->id = id;
            XBT_INFO("Send fork \"%s\" to %s",
                     MSG_task_get_name(task_tmp), mailbox);
            MSG_task_send(task_tmp2, mailbox);
            task_tmp2 = NULL;
            sprintf(mailbox, "%s_exe", worker[id]->name);
            res = MSG_task_receive(&task_tmp2, mailbox);
            xbt_assert(res == MSG_OK, "MSG_task_get failed");
            bool enable_push2 = (bool)MSG_task_get_data(task_tmp2);

            if(enable_push2){
              state_tmp->id = id;
              state_tmp->state = CREATED;
#ifndef visu
#ifndef light
              XBT_INFO("State DEP CREATED \"%s\"",
                       MSG_task_get_name(task_tmp));
#endif
#endif
#ifndef visu
#ifndef light
              XBT_INFO("Push \"%s\"", MSG_task_get_name(task_tmp));
#endif
#endif
              push_task(id, task_tmp);
            }
          }
        }else if(fork_state &&  !is_fork(task_node) ){
          //envoi de UP_DEP a la dht et attendre la reponse
          task_tmp = state_tmp->msg_task;
          sprintf(sprintf_buffer, "UP_DEP");
          m_task_t task_tmp2 = MSG_task_create(sprintf_buffer, 0, 100,
                                               task_tmp);
          sprintf(mailbox, "%s_dht", state_tmp->hostname);
          state_tmp->id = id;
          XBT_INFO("Send fork \"%s\" to %s for %s", sprintf_buffer, mailbox, agnameof(dag_tmp));
          MSG_task_send(task_tmp2, mailbox);
          //res = MSG_task_receive(&task_tmp, mailbox);
          //enable_push = (bool)MSG_task_get_data(task_tmp);
          //xbt_assert(res == MSG_OK, "MSG_task_get failed");

        }
      }
      work_stack = stacks[id].work_stack;
#ifdef visu
      XBT_INFO("w %g %d %Lf",MSG_get_clock(), id, work_stack);
#endif
      task_tmp=NULL;
      dag_tmp = NULL;
      state_tmp = NULL;
      dag_node=NULL;
      state_node=NULL;
      task_node=NULL;
    }else{
      stealing[id] = 1;
      last_active_time = MSG_get_clock();
    //  View1(id);
      if(slaves_count == 1){
      for (dag_tmp = agfstnode(dag_dot); dag_tmp; dag_tmp = agnxtnode(dag_dot,dag_tmp)){
        state_tmp  = (mynode*)(AGDATA(dag_tmp));
        if (state_tmp->state != FINISHED){
          task_tmp = state_tmp->msg_task;
          XBT_INFO("task not finished %s",MSG_task_get_name(task_tmp));
        }
      }
      }
      task_tmp = (m_task_t) steal(id);
#ifndef visu
#ifndef light
      XBT_INFO("Pop \"%s\"", MSG_task_get_name(task_tmp));
#endif
#endif
      /** the task finalize is receive */
      if (MSG_task_get_data(task_tmp) == FINALIZE) {
        //MSG_task_destroy(c_task);
        goto End_d;
      }

      if (MSG_task_get_data(task_tmp) != NO_TASK){
        /** if there are a task to execute */
        dag_tmp = MSG_task_get_data(task_tmp);
        state_tmp =	(mynode*)(AGDATA(dag_tmp));
        state_tmp->id = id;
#ifndef visu
#ifndef light
        XBT_INFO("Received \"%s\"", MSG_task_get_name(task_tmp));
        XBT_INFO("Push \"%s\"", MSG_task_get_name(task_tmp));
#endif
#endif
        push_task(id, task_tmp);
      }else{
#ifndef visu
#ifndef light
      XBT_INFO("Processing NO \"%s\"", MSG_task_get_name(task_tmp));
#endif
#endif
      MSG_task_execute(task_tmp);
#ifndef visu
#ifndef light
      XBT_INFO("\"%s\" done", MSG_task_get_name(task_tmp));
#endif
#endif
        //MSG_task_destroy(task_tmp);
      }
      work_stack = stacks[id].work_stack;
#ifdef visu
      XBT_INFO("w %g %d %Lf",MSG_get_clock(), id, work_stack);
#endif
    }
    task_tmp = NULL;
    dag_tmp = NULL;
    state_tmp = NULL;
  }
End:
  if (last_active_time != 0 ){
    inactivity_time +=  MSG_get_clock() - last_active_time;
#ifdef visu
    XBT_INFO("i %g %d %g",MSG_get_clock(), id, inactivity_time);
#endif
  }
  last_active_time=0;
  if (end_done){
    while(1){
      task_tmp = NULL;
      sprintf(mailbox, "%s_exe", worker[id]->name);
#ifndef visu
#ifndef light
      XBT_INFO("waiting end \"%s\"", mailbox);
#endif
#endif
      res = MSG_task_receive(&task_tmp, mailbox);
      xbt_assert(res == MSG_OK, "MSG_task_get failed");
      /** the task finalize is receive */
#ifndef visu
#ifndef light
      XBT_INFO("Received \"%s\"", MSG_task_get_name(task_tmp));
#endif
#endif
      if (MSG_task_get_data(task_tmp) == FINALIZE) {
        goto End_d;
      }
    }
  }
  end_done = true;
  m_task_t task;
#ifndef visu
#ifndef light
  XBT_INFO("Start finalization! nb finalise : %d ", slaves_count);
#endif
#endif
  for (i = 0; i < slaves_count; i++) {
    if(id != i){
      sprintf(mailbox, "%s_exe", worker[i]->name);
      task = MSG_task_create("finalize", 0, 0, FINALIZE);
#ifndef visu
#ifndef light
      XBT_INFO("Sending \"%s\" to \"%s\"", task->name, mailbox);
#endif
#endif
      MSG_task_send(task, mailbox);
    }
  }
  for (i = 0; i < slaves_count; i++) {
    sprintf(mailbox, "%s_task", worker[i]->name);
    task = MSG_task_create("finalize", 0, 0, FINALIZE);
#ifndef visu
#ifndef light
    XBT_INFO("Sending \"%s\" to \"%s\"", task->name, mailbox);
#endif
#endif
    MSG_task_send(task, mailbox);

    sprintf(mailbox, "%s_data", worker[i]->name);
    task = MSG_task_create("finalize", 0, 0, FINALIZE);
#ifndef visu
#ifndef light
    XBT_INFO("Sending \"%s\" to \"%s\"", task->name, mailbox);
#endif
#endif
    MSG_task_send(task, mailbox);

    sprintf(mailbox, "%s_dht", worker[i]->name);
    task = MSG_task_create("finalize", 0, 0, FINALIZE);
#ifndef visu
#ifndef light
    XBT_INFO("Sending \"%s\" to \"%s\"", task->name, mailbox);
#endif
#endif
    MSG_task_send(task, mailbox);

    sprintf(mailbox, "%s_ready", worker[i]->name);
    task = MSG_task_create("finalize", 0, 0, FINALIZE);
#ifndef visu
#ifndef light
    XBT_INFO("Sending \"%s\" to \"%s\"", task->name, mailbox);
#endif
#endif
    MSG_task_send(task, mailbox);
  }
End_d:
  if (last_active_time != 0 ){
    inactivity_time +=  MSG_get_clock() - last_active_time;
#ifdef visu
    XBT_INFO("i %g %d %g",MSG_get_clock(), id, inactivity_time);
#endif
  }
  last_active_time=0;
#ifndef visu
#ifndef light
  XBT_INFO("The work is done. See you!");
#endif
#endif
  return 0;
}                               /* end_of_execute_work */



/** Receiver function  */
int answer_request(int argc, char **argv)
{
  int i;
  m_task_t task;
  m_task_t send_task;
  mynode * state_send;
  Agnode_t * dag_send;
  MSG_error_t res;
  long double work_stack = 0;
  m_host_t host = MSG_host_self();
  int id = intialisation_data( argc,argv);
  const char * hostname = MSG_host_get_name(host);
#ifndef visu
#ifndef light
  XBT_INFO("hostname : %s", hostname);
#endif
#endif
  char mailbox[64];

  while (1) {
    task=NULL;
    sprintf(mailbox, "%s_task", hostname);
    res = MSG_task_receive(&task, mailbox);
    xbt_assert(res == MSG_OK, "MSG_task_get failed");

    m_host_t thief_id = MSG_task_get_source	(task);
    const char * hostname_thief = MSG_host_get_name(thief_id);
    sprintf(mailbox, "%s_exe", hostname_thief);

#ifndef visu
#ifndef light
    XBT_INFO("Received \"%s\"", MSG_task_get_name(task));
#endif
#endif

    if (MSG_task_get_data(task) == FINALIZE) {
      //MSG_task_destroy(task);
      break;
    }
    if (is_request(task)) {
      int thief_id = *(int*)MSG_task_get_data(task);
#ifndef visu
#ifndef light
      XBT_INFO("Processing \"%s\"", MSG_task_get_name(task));
#endif
#endif
      MSG_task_execute(task);
#ifndef visu
#ifndef light
      XBT_INFO("\"%s\" done", MSG_task_get_name(task));
#endif
#endif
      //MSG_task_destroy(task);
      task = NULL;
      /** get a task and send it to the thief */
      send_task = NULL;
      if (stealing[id] == 0)
        do {
          if (vol == ONE){
    //        XBT_INFO("steal ONE");
            send_task = (m_task_t) steal_task(id);
          }else{
      //      XBT_INFO("steal HALF");
            send_task	= (m_task_t) steal_tasks(id, thief_id);
          }
          if(send_task == NULL) break;
#ifndef visu
#ifndef light
          XBT_INFO("Pop \"%s\"", MSG_task_get_name(send_task));
#endif
#endif
          dag_send = MSG_task_get_data(send_task);
          state_send =	(mynode*)(AGDATA(dag_send));
        } while (( state_send->state >= WAITING ));
      work_stack = stacks[id].work_stack;
#ifdef visu
      XBT_INFO("w %g %d %Lf", MSG_get_clock(), id, work_stack);
#endif
      if(send_task == NULL){
        char * name = "NO_Task";
        send_task = MSG_task_create(name, 160000000, 100, NO_TASK);
#ifdef TRACE
        TRACE_msg_set_task_category(send_task, "NO_TASK");
#endif
#ifndef visu
#ifndef light
        XBT_INFO("Sending \"%s\" to \"%s\"", send_task->name, worker[thief_id]->name);
#endif
#endif
        MSG_task_send_with_timeout(send_task, mailbox, 1);
#ifndef visu
#ifndef light
        XBT_INFO("Sent");
#endif
#endif
      } else {
        state_send->state = STOLEN;
#ifndef visu
#ifndef light
        XBT_INFO("State STOLEN \"%s\"", MSG_task_get_name(send_task));
        XBT_INFO("Sending \"%s\" to \"%s\"", send_task->name, worker[thief_id]->name);
#endif
#endif
        MSG_task_send(send_task, mailbox);
#ifndef visu
#ifndef light
        XBT_INFO("Sent");
#endif
#endif
      }	
    }else{
      return 32123;
    }
  }
#ifndef visu
#ifndef light
  XBT_INFO("I'm done. See you!");
#endif
#endif
  return 0;
}                               /* end_of_slave */

/** data sender  */
int data_sender(int argc, char *argv[])
{
  int i;
  int id = intialisation_data( argc,argv);
  m_task_t task;
  m_task_t send_task;
  m_host_t host = MSG_host_self();
  const char * hostname = MSG_host_get_name(host);
  MSG_error_t res = MSG_TASK_CANCELLED;
  char sprintf_buffer[512];
  char mailbox[64];
#ifndef visu
#ifndef light
  XBT_INFO("hostname : %s", hostname);
#endif
#endif

  while (1) {
    task=NULL;
    sprintf(mailbox, "%s_data", hostname);
    res = MSG_task_receive(&task, mailbox);
    xbt_assert(res == MSG_OK, "MSG_task_get failed");

#ifndef visu
#ifndef light
    XBT_INFO("Received \"%s\"", MSG_task_get_name(task));
#endif
#endif
    if (MSG_task_get_data(task) == FINALIZE) {
      MSG_task_destroy(task);
      break;
    }
    if (is_data(task)) {
      m_host_t thief_id = MSG_task_get_source(task);
      const char * hostname_thief = MSG_host_get_name(thief_id);
      sprintf(mailbox, "%s_exe", hostname_thief);
      double cost_data = *(double*)MSG_task_get_data(task);
      free((double*)MSG_task_get_data(task));
      sprintf(sprintf_buffer, "send_%s", task->name);
     // MSG_task_destroy(task);
      task = NULL;
      send_task = MSG_task_create(sprintf_buffer, 0, cost_data, NULL);
#ifdef TRACE
      TRACE_msg_set_task_category(send_task, "DATA");
#endif
#ifndef visu
#ifndef light
      XBT_INFO("Sending \"%s\" by \"%d\"", send_task->name, id);
#endif
#endif
      MSG_task_send(send_task, mailbox);
#ifndef visu
#ifndef light
      XBT_INFO("Sent");
#endif
#endif
    }else{
      return 32123;
    }
  }
#ifndef visu
#ifndef light
  XBT_INFO("I'm done. See you!");
#endif
#endif
  return 0;
}                               /* end_of_slave */

/** DHT  */
int DHT(int argc, char *argv[])
{
  int i;
  mynode * state;
  mynode * state_tmp;
  Agnode_t * dag;
  Agnode_t * dag_tmp;
  m_task_t task, send_task;
  m_task_t task_request;
  int id = intialisation_data( argc,argv);
  m_host_t host = MSG_host_self();
  const char * hostname = MSG_host_get_name(host);
  MSG_error_t res = MSG_TASK_CANCELLED;
  char sprintf_buffer[512];
  char mailbox[64];
#ifndef visu
#ifndef light
  XBT_INFO("hostname : %s", hostname);
#endif
#endif

  while (1) {
    task=NULL;
    sprintf(mailbox, "%s_dht", hostname);
    XBT_INFO("wait a task");
    res = MSG_task_receive(&task, mailbox);
    xbt_assert(res == MSG_OK, "MSG_task_get failed");

    //sprintf_buffer = MSG_task_get_name(task_tmp);
    if (MSG_task_get_data(task) == FINALIZE) {
      MSG_task_destroy(task);
      break;
    }

    m_host_t thief_id = MSG_task_get_source	(task);
    const char * hostname_thief = MSG_host_get_name(thief_id);
    task_request = (m_task_t)MSG_task_get_data(task);
    dag = MSG_task_get_data(task_request);
    state =	(mynode*)(AGDATA(dag));
#ifndef visu
#ifndef light
    XBT_INFO("Received \"%s\" for : \"%s\"", MSG_task_get_name(task),
          MSG_task_get_name(task_request));
#endif
#endif

    /** part of code for the dht without metha fork **/
    if (test_string(task->name,"DEP",3)) {
      /** update dependencies and answer if the task need to be fork*/
      bool fork_dht = is_ready(task_request);
      if (fork_dht && !state->fork){
        XBT_INFO("creation task : %s\n", MSG_task_get_name(task_request));
        state->fork = true;
        state->ready = true;
      }else{
        XBT_INFO("pas creation task : %s\n", MSG_task_get_name(task_request));
        fork_dht = false;
      }
      sprintf(sprintf_buffer, "DHT_FORK");
      send_task = MSG_task_create(sprintf_buffer, 0, 0, (void*)fork_dht );
    } else if (test_string(agnameof(dag),"PUSH",4)) {
      /** push the task in the stack of this process */
      return 1111;
      push_task(id, task_request);
      send_task = NULL;
    }

    /** part of code for the dht with metha fork **/
    else if (test_string(task->name,"REQ_FORK",8)) {
      /* answer if the task need to be fork */
      bool fork_dht = true;
      if(state->fork == true)
        fork_dht = false;	
      state->fork = true;
      sprintf(sprintf_buffer, "DHT_FORK");
      send_task = MSG_task_create(sprintf_buffer, 0, 0, (void*)fork_dht );
    } else if (test_string(task->name,"UP_DEP",6)) {
      /* update dependencies and send to the owner the information if the task is ready */
      if(is_ready(task_request)){
        if( strlen(hostname_thief) != strlen(hostname) ||
            !test_string(hostname,hostname_thief,strlen(hostname_thief))){
          XBT_INFO("string not equal : %s != %s",hostname_thief,hostname);
          sprintf(sprintf_buffer, "READY");
          send_task = MSG_task_create(sprintf_buffer, 0, 0, task_request);
          sprintf(mailbox, "%s_ready", hostname_thief);
          MSG_task_send(send_task, mailbox);
        }else{
          XBT_INFO("string equal : %s = %s",hostname_thief,hostname);
          state->ready = true;
        }
      }
      send_task = NULL;
    } else if (test_string(task->name,"READY",5)) {
      state->ready = true;
    } else{
      XBT_INFO("Error recieve \"%s\" from \"%s\"", task->name, thief_id->name);
      return 32123;
    }
    //MSG_task_destroy(task);
    task = NULL;
    if (send_task != NULL){
      sprintf(mailbox, "%s_exe", hostname_thief);
#ifdef TRACE
      TRACE_msg_set_task_category(send_task, "DHT");
#endif
#ifndef visu
#ifndef light
      XBT_INFO("Sending \"%s\" to \"%s\"", send_task->name, hostname_thief);
#endif
#endif
      MSG_task_send(send_task, mailbox);
#ifndef visu
#ifndef light
      XBT_INFO("Sent");
#endif
#endif
    }
    send_task=NULL;
  }
#ifndef visu
#ifndef light
  XBT_INFO("I'm done. See you!");
#endif
#endif
  return 0;
}                               /* end_of_slave */

/** Test function */
MSG_error_t test_all(const char *platform_file, const char *application_file)
{
  MSG_error_t res = MSG_OK;

  /* MSG_config("surf_workstation_model","KCCFLN05"); */
  {                             /*  Simulation setting */
    MSG_set_channel_number(MAX_CHANNEL);
#ifndef TRACE
    //MSG_paje_output("ws_test.trace");
#endif
    MSG_create_environment(platform_file);
  }
  {                             /*   Application deployment */
    MSG_function_register("execute_task", execute_task);
    MSG_function_register("answer_request", answer_request);
    MSG_function_register("data_sender", data_sender);
    MSG_function_register("data_receiver", data_receiver);
    MSG_function_register("push_data", push_data);
    MSG_function_register("answer_ready", answer_ready);
    MSG_function_register("dht", DHT);
    MSG_launch_application(application_file);
  }
  res = MSG_main();

#ifndef visu
  XBT_INFO("Simulation time %g", MSG_get_clock());
#endif
  free(worker);
  return res;
}                               /* end_of_test_all */


/** Main function */
int main(int argc, char *argv[])
{
  MSG_error_t res = MSG_OK;
  MSG_global_init(&argc, argv);
#ifdef TRACE
  if (argc < 6) {
    printf("Usage: %s platform_file deployment_file trace_file < dot_file\n", argv[0]);
    printf("example: %s msg_platform.xml msg_deployment.xml (ON0 | RR | RAND | \
      GIVEN) seed ws.trace < msg_dag.dot\n", argv[0]);
    exit(1);
  }
#else
  if (argc < 6) {
    printf("Usage: %s platform_file deployment_file a_placement seed < dot_file\n", argv[0]);
    printf("example: %s msg_platform.xml msg_deployment.xml (ON0 | RR | RAND | GIVEN) seed (ONE | HALF) < msg_dag.dot\n", argv[0]);
    exit(1);
  }
#endif
  long long int seed = atoll(argv[4]);
#ifndef visu
#ifndef light
  XBT_INFO("seed : %lld",(long long int)seed);
#endif
#endif
  srand ( seed );
  dag_dot = agread(stdin,NIL(Agdisc_t*));
  switch((int)argv[3][0]){
    case 'O':
      placement = ON0;
      break;
    case 'R':
      switch((int)argv[3][1]){
        case 'A' :
          placement = RAND;
          break;
        case 'R' :
          placement = RR;
          break;
      }
      break;
    case 'G':
      placement = GIVEN;
      break;
  }

  switch((int)argv[5][0]){
    case 'O':
      XBT_INFO("steal ONE");
      vol = ONE;
      break;
    case 'H':
      XBT_INFO("steal HALF");
      vol = HALF;
  }
#ifdef TRACE
  TRACE_start(argv[5]);
  TRACE_category("REQUEST");
  TRACE_category("NO_TASK");
  TRACE_category("FORK");
  TRACE_category("DATA");
  TRACE_category("ASK_DATA");
  TRACE_category("TASK");
#endif
  res = test_all(argv[1], argv[2]);
#ifdef TRACE
  TRACE_end();
#endif
  MSG_clean();

  if (res == MSG_OK)
    return 0;
  else
    return 1;
}                               /* end_of_main */
